/*
 * oscp-slave-sid2-prepare.c
 * Copyright (C) 2015 KotCzarny <tjosko@yahoo.com>
 *
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the
 *  Free Software Foundation; either version 2 of the License, or (at your
 *  option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include <stdio.h>
#include <string.h>

////#################
int md5toint(char *a) { unsigned int v1, v2, v3, v4; sscanf(a+0, "%8x", &v1);
 sscanf(a+8, "%8x", &v2); sscanf(a+16, "%8x", &v3); sscanf(a+24, "%8x", &v4);
 int hash = v1 ^ v2 ^ v3 ^ v4;
// char lmsg[1024]; snprintf(lmsg, 1023, "md5toint: %s, %8x %8x %8x %8x, hash: %8x", a, v1, v2, v3,
 return hash;
}

////######
int main() { char *fn="hvsc62-songlengths.txt";
 FILE *f2=fopen("oscp-slave-sid2-prepared.c", "w");
 char out[1024]; sprintf(out, "int sid2_getdur(int a){ switch(a) {\n");
 fwrite(out, strlen(out), 1, f2);

 FILE *f=fopen(fn,"r");
 if(!f) { printf("can't open source: %s", fn); return -1; }
 int feof=0; char buf[4096];
 int i, hash, min, sec; char md5[36], times[128];
 while(feof==0) {
  buf[0]=0; fgets(buf, 4095, f); if(buf[0]==0) { feof=1; break; }
  i=sscanf(buf, "%32s=%d:%d%127s", &md5, &min, &sec, &times);
  if(i>=3)
  {
//   printf("(%d) %s", i, buf);
   md5[0]=65+0; hash=md5toint(md5);
//   printf("hash: %8x, md5: %s, min: %d, sec: %d, times: %s\n", hash, md5, min, sec, times);
// 1 378 945 045
sprintf(out, "case 0x%08x :return %d;break; // %+09d\n", hash, min*60+sec, hash);
fwrite(out, strlen(out), 1, f2);
//return;
  }
 }
sprintf(out, "} return -1;}\n");
fwrite(out, strlen(out), 1, f2);

 return 0;
}